/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_MammographyImageQualityFinding;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_MammographyImageQualityFinding;


/**
 * This class represents MammographyImageQualityFinding - CID6041
 */
public class MammographyImageQualityFinding_CID6041
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new MammographyImageQualityFinding_CID6041 Template 
	 */
	public MammographyImageQualityFinding_CID6041()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumMammographyImageQualityFinding Object of EnumCM_MammographyImageQualityFinding represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_MammographyImageQualityFinding enumMammographyImageQualityFinding)
	{
		switch(enumMammographyImageQualityFinding)
		{
		case VIEW_AND_LATERALITY_MARKER_IS_MISSING: this.strCodeValue = EnumCV_MammographyImageQualityFinding.VIEW_AND_LATERALITY_MARKER_IS_MISSING_111177.getValue();break;
		case VIEW_AND_LATERALITY_MARKER_DOES_NOT_HAVE_BOTH_VIEW_AND_LATERALITY: this.strCodeValue = EnumCV_MammographyImageQualityFinding.VIEW_AND_LATERALITY_MARKER_DOES_NOT_HAVE_BOTH_VIEW_AND_LATERALITY_111178.getValue();break;
		case VIEW_AND_LATERALITY_MARKER_DOES_NOT_HAVE_APPROVED_CODES: this.strCodeValue = EnumCV_MammographyImageQualityFinding.VIEW_AND_LATERALITY_MARKER_DOES_NOT_HAVE_APPROVED_CODES_111179.getValue();break;
		case VIEW_AND_LATERALITY_MARKER_IS_NOT_NEAR_THE_AXILLA: this.strCodeValue = EnumCV_MammographyImageQualityFinding.VIEW_AND_LATERALITY_MARKER_IS_NOT_NEAR_THE_AXILLA_111180.getValue();break;
		case VIEW_AND_LATERALITY_MARKER_OVERLAPS_BREAST_TISSUE: this.strCodeValue = EnumCV_MammographyImageQualityFinding.VIEW_AND_LATERALITY_MARKER_OVERLAPS_BREAST_TISSUE_111181.getValue();break;
		case VIEW_AND_LATERALITY_MARKER_IS_PARTIALLY_OBSCURED: this.strCodeValue = EnumCV_MammographyImageQualityFinding.VIEW_AND_LATERALITY_MARKER_IS_PARTIALLY_OBSCURED_111182.getValue();break;
		case VIEW_AND_LATERALITY_MARKER_IS_INCORRECT: this.strCodeValue = EnumCV_MammographyImageQualityFinding.VIEW_AND_LATERALITY_MARKER_IS_INCORRECT_111183.getValue();break;
		case VIEW_AND_LATERALITY_MARKER_IS_OFF_IMAGE: this.strCodeValue = EnumCV_MammographyImageQualityFinding.VIEW_AND_LATERALITY_MARKER_IS_OFF_IMAGE_111184.getValue();break;
		case FLASH_IS_NOT_NEAR_EDGE_OF_FILM: this.strCodeValue = EnumCV_MammographyImageQualityFinding.FLASH_IS_NOT_NEAR_EDGE_OF_FILM_111185.getValue();break;
		case FLASH_IS_ILLEGIBLE_DOES_NOT_FIT_OR_IS_LOPSIDED: this.strCodeValue = EnumCV_MammographyImageQualityFinding.FLASH_IS_ILLEGIBLE_DOES_NOT_FIT_OR_IS_LOPSIDED_111186.getValue();break;
		case FLASH_DOESNT_INCLUDE_PATIENT_NAME_AND_ADDITIONAL_PATIENT_ID: this.strCodeValue = EnumCV_MammographyImageQualityFinding.FLASH_DOESNT_INCLUDE_PATIENT_NAME_AND_ADDITIONAL_PATIENT_ID_111187.getValue();break;
		case FLASH_DOESNT_INCLUDE_DATE_OF_EXAMINATION: this.strCodeValue = EnumCV_MammographyImageQualityFinding.FLASH_DOESNT_INCLUDE_DATE_OF_EXAMINATION_111188.getValue();break;
		case FLASH_DOESNT_INCLUDE_FACILITY_NAME_AND_LOCATION: this.strCodeValue = EnumCV_MammographyImageQualityFinding.FLASH_DOESNT_INCLUDE_FACILITY_NAME_AND_LOCATION_111189.getValue();break;
		case FLASH_DOESNT_INCLUDE_TECHNOLOGIST_IDENTIFICATION: this.strCodeValue = EnumCV_MammographyImageQualityFinding.FLASH_DOESNT_INCLUDE_TECHNOLOGIST_IDENTIFICATION_111190.getValue();break;
		case FLASH_DOESNT_INCLUDE_CASSETTE_SCREEN_DETECTOR_IDENTIFICATION: this.strCodeValue = EnumCV_MammographyImageQualityFinding.FLASH_DOESNT_INCLUDE_CASSETTE_SCREEN_DETECTOR_IDENTIFICATION_111191.getValue();break;
		case FLASH_DOESNT_INCLUDE_MAMMOGRAPHY_UNIT_IDENTIFICATION: this.strCodeValue = EnumCV_MammographyImageQualityFinding.FLASH_DOESNT_INCLUDE_MAMMOGRAPHY_UNIT_IDENTIFICATION_111192.getValue();break;
		case DATE_STICKER_IS_MISSING: this.strCodeValue = EnumCV_MammographyImageQualityFinding.DATE_STICKER_IS_MISSING_111193.getValue();break;
		case TECHNICAL_FACTORS_MISSING: this.strCodeValue = EnumCV_MammographyImageQualityFinding.TECHNICAL_FACTORS_MISSING_111194.getValue();break;
		case COLLIMATION_TOO_CLOSE_TO_BREAST: this.strCodeValue = EnumCV_MammographyImageQualityFinding.COLLIMATION_TOO_CLOSE_TO_BREAST_111195.getValue();break;
		case INADEQUATE_COMPRESSION: this.strCodeValue = EnumCV_MammographyImageQualityFinding.INADEQUATE_COMPRESSION_111196.getValue();break;
		case MLO_INSUFFICIENT_PECTORAL_MUSCLE: this.strCodeValue = EnumCV_MammographyImageQualityFinding.MLO_INSUFFICIENT_PECTORAL_MUSCLE_111197.getValue();break;
		case MLO_NO_FAT_IS_VISUALIZED_POSTERIOR_TO_FIBROGLANDULAR_TISSUES: this.strCodeValue = EnumCV_MammographyImageQualityFinding.MLO_NO_FAT_IS_VISUALIZED_POSTERIOR_TO_FIBROGLANDULAR_TISSUES_111198.getValue();break;
		case MLO_POOR_SEPARATION_OF_DEEP_AND_SUPERFICIAL_BREAST_TISSUES: this.strCodeValue = EnumCV_MammographyImageQualityFinding.MLO_POOR_SEPARATION_OF_DEEP_AND_SUPERFICIAL_BREAST_TISSUES_111199.getValue();break;
		case MLO_EVIDENCE_OF_MOTION_BLUR: this.strCodeValue = EnumCV_MammographyImageQualityFinding.MLO_EVIDENCE_OF_MOTION_BLUR_111200.getValue();break;
		case MLO_INFRAMAMMARY_FOLD_IS_NOT_OPEN: this.strCodeValue = EnumCV_MammographyImageQualityFinding.MLO_INFRAMAMMARY_FOLD_IS_NOT_OPEN_111201.getValue();break;
		case CC_NOT_ALL_MEDIAL_TISSUE_VISUALIZED: this.strCodeValue = EnumCV_MammographyImageQualityFinding.CC_NOT_ALL_MEDIAL_TISSUE_VISUALIZED_111202.getValue();break;
		case CC_NIPPLE_NOT_CENTERED_ON_IMAGE: this.strCodeValue = EnumCV_MammographyImageQualityFinding.CC_NIPPLE_NOT_CENTERED_ON_IMAGE_111203.getValue();break;
		case CC_POSTERIOR_NIPPLE_LINE_DOES_NOT_MEASURE_WITHIN_CM_OF_MLO: this.strCodeValue = EnumCV_MammographyImageQualityFinding.CC_POSTERIOR_NIPPLE_LINE_DOES_NOT_MEASURE_WITHIN_CM_OF_MLO_111204.getValue();break;
		case NIPPLE_NOT_IN_PROFILE: this.strCodeValue = EnumCV_MammographyImageQualityFinding.NIPPLE_NOT_IN_PROFILE_111205.getValue();break;
		case INSUFFICIENT_IMPLANT_DISPLACEMENT_INCORRECT: this.strCodeValue = EnumCV_MammographyImageQualityFinding.INSUFFICIENT_IMPLANT_DISPLACEMENT_INCORRECT_111206.getValue();break;
		case GRID_ARTIFACTS: this.strCodeValue = EnumCV_MammographyImageQualityFinding.GRID_ARTIFACTS_111208.getValue();break;
		case POSITIONING: this.strCodeValue = EnumCV_MammographyImageQualityFinding.POSITIONING_111209.getValue();break;
		case MOTION_BLUR: this.strCodeValue = EnumCV_MammographyImageQualityFinding.MOTION_BLUR_111210.getValue();break;
		case UNDER_EXPOSED: this.strCodeValue = EnumCV_MammographyImageQualityFinding.UNDER_EXPOSED_111211.getValue();break;
		case OVER_EXPOSED: this.strCodeValue = EnumCV_MammographyImageQualityFinding.OVER_EXPOSED_111212.getValue();break;
		case NO_IMAGE: this.strCodeValue = EnumCV_MammographyImageQualityFinding.NO_IMAGE_111213.getValue();break;
		case DETECTOR_ARTIFACTS: this.strCodeValue = EnumCV_MammographyImageQualityFinding.DETECTOR_ARTIFACTS_111214.getValue();break;
		case ARTIFACTS_OTHER_THAN_GRID_OR_DETECTOR_ARTIFACT: this.strCodeValue = EnumCV_MammographyImageQualityFinding.ARTIFACTS_OTHER_THAN_GRID_OR_DETECTOR_ARTIFACT_111215.getValue();break;
		case MECHANICAL_FAILURE: this.strCodeValue = EnumCV_MammographyImageQualityFinding.MECHANICAL_FAILURE_111216.getValue();break;
		case ELECTRICAL_FAILURE: this.strCodeValue = EnumCV_MammographyImageQualityFinding.ELECTRICAL_FAILURE_111217.getValue();break;
		case SOFTWARE_FAILURE: this.strCodeValue = EnumCV_MammographyImageQualityFinding.SOFTWARE_FAILURE_111218.getValue();break;
		case INAPPROPRIATE_IMAGE_PROCESSING: this.strCodeValue = EnumCV_MammographyImageQualityFinding.INAPPROPRIATE_IMAGE_PROCESSING_111219.getValue();break;
		case OTHER_FAILURE: this.strCodeValue = EnumCV_MammographyImageQualityFinding.OTHER_FAILURE_111220.getValue();break;
		case UNKNOWN_FAILURE: this.strCodeValue = EnumCV_MammographyImageQualityFinding.UNKNOWN_FAILURE_111221.getValue();break;
		}
	}

	/**
	 * Sets the value for MammographyImageQualityFinding
	 * @param enumMammographyImageQualityFinding Object of EnumCM_MammographyImageQualityFinding.
	 */
	public void setMammographyImageQualityFinding(EnumCM_MammographyImageQualityFinding enumMammographyImageQualityFinding)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumMammographyImageQualityFinding.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumMammographyImageQualityFinding);
	}
}
